CON
  _CLKMODE = xtal1 + pll16x
  _XINFREQ = 5_000_000 

OBJ
  synth : "tinysynth"
 
PUB main
  synth.start(10, 11)

  repeat
    testFilter
    testSawWave
    testTriangleWave
    testNoiseWave
    testPercussion
    testLockedPulseWidth
    testDecayRate
    testNoteOnOffAndPortamento









































CON
  tb1_pwinit = 3, tb1_pwmRate= 19, tb1_decRate= 16, tb1_susLevel = 64
      
PUB testFilter

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)       
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 1, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 2, 2, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 3, 3, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 4, 4, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 5, 5, false) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 6, 6, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 7, 7, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 8, 8, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate, 9, 9, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,10, 10, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,11, 11, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,12, 12, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,13, 13, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb1_decRate, tb1_susLevel, tb1_pwinit, tb1_pwmRate,14, 14, false)          
    waitcnt(cnt+20_000_000)

CON
  tb2_pwinit = 1, tb2_pwmRate = 0, tb2_decRate = 16, tb2_susLevel = 64, tb2_filtLevel1 = 0, tb2_filtLevel2 = 11
      
PUB testSawWave

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)          
    waitcnt(cnt+20_000_000)                                                
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb2_decRate, tb2_susLevel, tb2_pwinit, tb2_pwmRate, tb2_filtLevel1, tb2_filtLevel2, false)          
    waitcnt(cnt+20_000_000)

CON
  tb6_pwinit = 256, tb6_pwmRate = 0, tb6_decRate = 16, tb6_susLevel = 64, tb6_filtLevel1 = 9, tb6_filtLevel2 = 9
      
PUB testTriangleWave

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)          
    waitcnt(cnt+20_000_000)                                                
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb6_decRate, tb6_susLevel, tb6_pwinit, tb6_pwmRate, tb6_filtLevel1, tb6_filtLevel2, false)          
    waitcnt(cnt+20_000_000)

CON
  tb7_pwinit = 256, tb7_pwmRate = 0, tb7_decRate = 17, tb7_susLevel = 64, tb7_filtLevel1 = 0, tb7_filtLevel2 = 0
      
PUB testNoiseWave

    'White noise: Different combinations of pwInit, pwRate and note will give different noise carateristics
    synth.pluck(0, tb7_decRate, tb7_susLevel, 1, 0, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(60, tb7_decRate, tb7_susLevel, 128, 0, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(64, tb7_decRate, tb7_susLevel, 128, 0, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(85, tb7_decRate, tb7_susLevel, 64, 0, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(85, tb7_decRate, tb7_susLevel, 0, 4, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(45, tb7_decRate, tb7_susLevel, 0, 4, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)    
    synth.pluck(45, tb7_decRate, tb7_susLevel, 0, 123, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(15, tb7_decRate, tb7_susLevel, 0, 2123, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(95, tb7_decRate, tb7_susLevel, 0, 1123, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(75, tb7_decRate, tb7_susLevel, 0, 128123, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
    synth.pluck(10, tb7_decRate, tb7_susLevel, 0, 128123, tb7_filtLevel1, tb7_filtLevel2, true)         
    waitcnt(cnt+80_000_000)
                                                        
CON
  tb3_pwinit = 256,tb3_pwmRate = 0,tb3_decRate = 16, tb3_susLevel = 64, tb3_filtLevel = 0
      
PUB testLockedPulseWidth

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel, 1, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 32,  tb3_pwmRate, tb3_filtLevel, 1, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel, 1, false) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 64,  tb3_pwmRate, tb3_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, tb3_decRate, tb3_susLevel, 256, tb3_pwmRate, tb3_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)

CON
  tb4_pwinit = 256,tb4_pwmRate = 0,tb4_decRate = 16, tb4_susLevel = 64, tb4_filtLevel = 0
   
PUB testDecayRate

    'pluck(midiNote, decayRate, sustainLevel, pulseWidthInit, pwmRate, filter)        
    synth.pluck(20, 13, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 13, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 14, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 14, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)             
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 15, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false) 
    waitcnt(cnt+20_000_000)
    synth.pluck(30, 15, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 16, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 16, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 17, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(30, 17, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)
    synth.pluck(20, 18, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)         
    waitcnt(cnt+20_000_000)
    synth.pluck(32, 18, tb4_susLevel, tb4_pwinit, tb4_pwmRate, tb4_filtLevel, 1, false)          
    waitcnt(cnt+20_000_000)

CON
  tb5_pwinit = 12, tb5_pwmRate = 52, tb5_attRate = 19, tb5_decRate = 18, tb5_susLevel = 60, tb5_filtLevel1 = 2, tb5_filtLevel2 = 7 
   
PUB testNoteOnOffAndPortamento

    'noteOn(midiNote, attackRate, sustainLevel, pulseWidthInit, pwmRate, fil)  
    synth.noteOn(30, tb5_attRate, tb5_susLevel, tb5_pwinit, tb5_pwmRate, tb5_filtLevel1, tb5_filtLevel2, false)         
    waitcnt(cnt+20_000_000)

    'slideToNote(midiNote, slideRate) 
    synth.slideToNote(42, 11)            
    waitcnt(cnt+30_000_000)
    synth.slideToNote(30, 11)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(42, 12)             
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 12) 
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 13)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 13)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 14)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(40, 14)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(52, 14)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(50, 15)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(62, 15)          
    waitcnt(cnt+30_000_000)
    synth.slideToNote(50, 16)         
    waitcnt(cnt+30_000_000)
    synth.slideToNote(62, 16)          
    waitcnt(cnt+30_000_000)

    'noteOff(decayRate)
    synth.noteOff(tb5_decRate)         
    waitcnt(cnt+80_000_000)
 
CON
  tb8_pwinit = 380, tb8_pwmRate = 520, tb8_attRate = 12, tb8_decRate = 15, tb8_susLevel = 60, tb8_filtLevel = 7, tb8_filtLevel2 = 8
  slideRate = 13, tb8_pwinit2 = 64, tb8_pwmRate2 = 0
  
PUB testPercussion

  'A purcussion is basically a tone sweeping very fast from a high frequency to a low frequency 
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate2, 0, 0, true)  
  waitcnt(cnt+20_000_000)  
  synth.sweep(62, 31, slideRate, tb8_decRate, tb8_susLevel-15, 64, 5256, 2, 3, false)
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate2, 3, 3, true)  
  waitcnt(cnt+20_000_000)
  '
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)   
  waitcnt(cnt+20_000_000)
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)   
  waitcnt(cnt+20_000_000)
  synth.sweep(62, 31, slideRate, tb8_decRate, tb8_susLevel-15, 64, 5256, 2, 3, false) 
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate2, 3, 3, true)  
  waitcnt(cnt+20_000_000)
  '
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate2, 0, 0, true)  
  waitcnt(cnt+20_000_000)  
  synth.sweep(62, 31, slideRate, tb8_decRate, tb8_susLevel-15, 64, 5256, 2, 3, false)
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate2, 3, 3, true)  
  waitcnt(cnt+20_000_000)
  '
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)   
  waitcnt(cnt+20_000_000)
  synth.sweep(54, 14, slideRate, tb8_decRate, tb8_susLevel, tb8_pwinit, tb8_pwmRate, tb8_filtLevel, tb8_filtLevel2, false)   
  waitcnt(cnt+20_000_000)
  synth.sweep(62, 31, slideRate, tb8_decRate, tb8_susLevel-15, 64, 5256, 2, 3, false) 
  waitcnt(cnt+20_000_000)
  synth.pluck(96, 15, 40, tb8_pwinit2,  tb8_pwmRate, 3, 3, true)  
  waitcnt(cnt+20_000_000)
  '                                                            